// DlgDevlist.cpp : _CAO - foCXXg
//

#include	"stdafx.h"
#include	"resource.h"
#include	"common.h"

#include	"wndproc.h"
#include	"dlgdevlist.h"

// defines
#define		SFMANCAPS	unsigned long

// ֐
template <class T> inline bool _and_mask( T x, T y ) {
	return ( (x & y) == y );
}

inline void _boxcheck( HWND hDlg, UINT id ) {
	CheckDlgButton( hDlg, id, BST_CHECKED );
}

inline bool _ischecked( HWND hDlg, UINT id ) {
	return ( IsDlgButtonChecked(hDlg, id) == BST_CHECKED );
}

// 
bool DDevlist::Init( HWND hDlg )
{
	InitLV( hDlg );
	InitCBX( hDlg );
	EnumDevices();

	// ftHg
	_boxcheck( hDlg, IDCC_ADD );

	if( pWnd->pTable->bGM )		_boxcheck( hDlg, IDCC_GM );
	if( pWnd->pTable->bExt )	_boxcheck( hDlg, IDCC_EXT );
	if( pWnd->pTable->bDrum )	_boxcheck( hDlg, IDCC_DRUM );

	char sNum[8];
	SetDlgItemText( hDlg, IDCE_START, itoa(pWnd->pTable->iStart, sNum, 10) );
	SetDlgItemText( hDlg, IDCE_END, itoa(pWnd->pTable->iEnd, sNum, 10) );

	// SPIN
	HWND hwSPS, hwSPE;
	hwSPS = GetDlgItem( hDlg, IDCSP_START );
	hwSPE = GetDlgItem( hDlg, IDCSP_END );

	_sndm( hwSPS, UDM_SETRANGE, 0, MAKELONG(1, 127) );
	_sndm( hwSPE, UDM_SETRANGE, 0, MAKELONG(1, 127) );

	UDACCEL uac;
	uac.nInc = (UINT)-1;
	uac.nSec = 1;
	_sndm( hwSPS, UDM_SETACCEL, 1, (LPARAM)&uac );
	_sndm( hwSPE, UDM_SETACCEL, 1, (LPARAM)&uac );

	// I
	SetItemSel( pWnd->pTable->iDeviceID );
	DeviceCaps();

	return TRUE;
}

// 
void DDevlist::Exit( HWND hDlg )
{
	// result
	pWnd->pTable->iDeviceID = GetSelectedItem();

	pWnd->pTable->bGM = _ischecked( hDlg, IDCC_GM );
	pWnd->pTable->bExt = _ischecked( hDlg, IDCC_EXT );
	pWnd->pTable->bDrum = _ischecked( hDlg, IDCC_DRUM );

	char sNum[8];
	GetDlgItemText( hDlg, IDCE_START, sNum, sizeof(sNum) );
	pWnd->pTable->iStart = atoi( sNum );

	GetDlgItemText( hDlg, IDCE_END, sNum, sizeof(sNum) );
	pWnd->pTable->iEnd = atoi( sNum );

	// z̉: dv
	free( pCaps );

	// LV
	if( !_ischecked(hDlg, IDCC_ADD) )
		pWnd->wLV.DeleteAll();
}

// LV̏
#define		ITEM_FIRST		IDS_DEVID	// ŏ̍
void DDevlist::InitLV( HWND hDlg )
{
	hdLV = GetDlgItem( hDlg, IDCL_DEVS );
	pWnd->wIList.SetImageListLV( hdLV );

	// R
	char sCol[128];
	RECT rt;
	GetClientRect( hdLV, &rt );

	LVCOLUMN itc;
	itc.mask = LVCF_WIDTH | LVCF_TEXT;
	itc.cx = (rt.right) / 2;
	itc.pszText = sCol;
	itc.cchTextMax = sizeof(sCol);

	LoadString( hInst, IDS_ITEM, sCol, sizeof(sCol) );
	ListView_InsertColumn( hdLV, 0, &itc );
	LoadString( hInst, IDS_VALUE, sCol, sizeof(sCol) );
	ListView_InsertColumn( hdLV, 1, &itc );

	// 
	int i;
	int iImage[] = {
		pWnd->wIList.icnSFDev,
		pWnd->wIList.icnDLL,
		pWnd->wIList.icnDLL,
		pWnd->wIList.icnDevice,
		pWnd->wIList.icnHardMem,
		pWnd->wIList.icnHardMem,
		pWnd->wIList.icnHardMem,
		pWnd->wIList.icnSFDev
	};

	LVITEM it;
	it.mask = LVIF_TEXT | LVIF_IMAGE;
	it.pszText = sCol;
	it.cchTextMax = sizeof(sCol);
	it.iSubItem = 0;

	for( i=0; i < (sizeof(iImage) / sizeof(int) ); i++ ) {
		LoadString( hInst, ITEM_FIRST + i, sCol, sizeof(sCol) );
		it.iImage = iImage[i];
		it.iItem = i;
		ListView_InsertItem( hdLV, &it );
	}
}

// ComboEx̏
void DDevlist::InitCBX( HWND hDlg )
{
	hdCBX = GetDlgItem( hDlg, IDC_CBX );
	pWnd->wIList.SetImageListCBX( hdCBX );
}

// foCX̗
void DDevlist::EnumDevices()
{
	// z̊m
	int nDevs = pWnd->pSf->DevGetNum();
	pCaps = (PSFCAPSOBJECT)calloc( nDevs, sizeof(CSFCapsObject) );

	// foCX
	CSFCapsObject sfCaps;
	sfCaps.m_SizeOf = sizeof(CSFCapsObject);

	// COMBOBOXEXITEM̃Zbg
	COMBOBOXEXITEM itcb;
	itcb.mask = CBEIF_TEXT | CBEIF_IMAGE | CBEIF_SELECTEDIMAGE;
	itcb.iImage = pWnd->wIList.icnDevice;
	itcb.iSelectedImage = pWnd->wIList.icnDevice;
	itcb.iItem = -1;
	itcb.pszText = sfCaps.m_DevName;
	itcb.cchTextMax = sizeof(sfCaps.m_DevName);

	int n;
	for( n = 0; n < nDevs; n++ ) {
		// foCX擾
		pWnd->pSf->GetDevCaps( n, &sfCaps );
		// CBXɒǉ
		_sndm( hdCBX, CBEM_INSERTITEM, 0, &itcb );
		// z̃Rs[
		pCaps[n] = sfCaps;
	}
}

// foCX̃vpeBXg
void DDevlist::DeviceCaps()
{
	int n = (int)_sndm( hdCBX, CB_GETCURSEL, 0, 0 );

	// common local, pointer pCaps[n]
	char sCom[128];

	// LVITEM
	LVITEM itDev;
	itDev.mask = LVIF_TEXT;
	itDev.iSubItem = 1;

	// DLL
	itDev.iItem = 1;
	itDev.pszText = pCaps[n].m_DevMgrName;
	itDev.cchTextMax = sizeof(pCaps[n].m_DevMgrName);
	ListView_SetItem( hdLV, &itDev );

	// DLL
	itDev.iItem = 2;
	itDev.pszText = pCaps[n].m_DevMgrEntry;
	itDev.cchTextMax = sizeof(pCaps[n].m_DevMgrName);
	ListView_SetItem( hdLV, &itDev );

	// ȉ
	itDev.cchTextMax = sizeof(sCom);
	itDev.pszText = sCom;

	// ID
	itDev.iItem = 0;
	itoa( n, sCom, 10 );
	ListView_SetItem( hdLV, &itDev );

	// VZ
	LoadString(	hInst,
		_and_mask( pCaps[n].m_DevCaps, (SFMANCAPS)SFMANCAP_SOFTWARE_SYNTH_CAP)
			?IDS_SOFTSYNTH:IDS_HARDSYNTH,
		sCom, sizeof(sCom) );
	itDev.iItem = 3;
	ListView_SetItem( hdLV, &itDev );

	// 
	LoadString(	hInst,
		_and_mask(pCaps[n].m_DevCaps, (SFMANCAPS)SFMANCAP_DYNAMIC_MEM_CAP)
			?IDS_SOFTMEM:IDS_HARDMEM,
		sCom, sizeof(sCom) );
	itDev.iItem = 4;
	ListView_SetItem( hdLV, &itDev );

	// ROM ID
	if( !pCaps[n].m_RomID )		LoadString( hInst, IDS_NONE, sCom, sizeof(sCom) );
	else						ultoa( pCaps[n].m_RomID, sCom, 16 );
	itDev.iItem = 5;
	ListView_SetItem( hdLV, &itDev );

	// ROM Ver
	if( !pCaps[n].m_RomVer )	LoadString( hInst, IDS_NONE, sCom, sizeof(sCom) );
	else						ultoa( pCaps[n].m_RomVer, sCom, 10 );
	itDev.iItem = 6;
	ListView_SetItem( hdLV, &itDev );

	// [^ ID
	ultoa( pCaps[n].m_RouterID, sCom, 16 );
	itDev.iItem = 7;
	ListView_SetItem( hdLV, &itDev );
}

// IꂽACe擾
int DDevlist::GetSelectedItem()
{
	int n;
	char sText[80];

	n = (int)_sndm( hdCBX, CB_GETCURSEL, 0, 0 );

	sprintf( sText, "ID%d: %s", n, pCaps[n].m_DevName );
	pWnd->wStatus.SetTextDev( sText );

	return n;
}

// CfbNXn ̃ACeIԂ
void DDevlist::SetItemSel( int n )
{
	_sndm( hdCBX, CB_SETCURSEL, n, 0 );
}

// IDCC_EXTEDITȂǂgO
void DDevlist::ClickExt( HWND hDlg )
{
	UINT uItem[] = {
		IDCS_EXT1,
		IDCS_EXT2,
		IDCS_EXT3,
		IDCS_EXT4,
		IDCE_START,
		IDCE_END,
		IDCSP_START,
		IDCSP_END,
	};

	int i;
	for( i=0; i< (sizeof(uItem) / sizeof(UINT)); i++ )
		SetWindowLong(
			GetDlgItem(hDlg, uItem[i]),
			GWL_STYLE,
			_ischecked(hDlg, IDCC_EXT)
				?(GetWindowLong(GetDlgItem(hDlg, uItem[i]), GWL_STYLE) & ~WS_DISABLED)
				:(GetWindowLong(GetDlgItem(hDlg, uItem[i]), GWL_STYLE) | WS_DISABLED)
		);

	RedrawWindow( hDlg, NULL, NULL, RDW_INVALIDATE );
}

// _CAOE[v(foCXXg)
static DDevlist*	dDevs;
BOOL APIENTRY DlgDevProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
		case WM_INITDIALOG:
			_chkmsg( dDevs->Init(hDlg), IDS_DLGINIT, hDlg );
			return TRUE;

		case WM_COMMAND:
			switch( LOWORD(wParam) ) {
				case IDOK:
					dDevs->Exit( hDlg );
					EndDialog( hDlg, TRUE );
					break;

				case IDCANCEL:
					EndDialog( hDlg, FALSE );
					break;

				case IDC_CBX:
					if( HIWORD(wParam) == CBN_SELCHANGE )
						dDevs->DeviceCaps();
					break;

				case IDCC_EXT:
					if( HIWORD(wParam) == BN_CLICKED )
						dDevs->ClickExt( hDlg );
					break;

				default:
					return FALSE;
			}
			return TRUE;

		case WM_NOTIFY:
			break;
	}
	return FALSE;

	_unused( lParam );
}

// _CAOs
int DDevlist::DoDialog( WndMain *pWndMain )
{
	dDevs = this;
	pWnd = pWndMain;

	if( !DialogBox(hInst, (LPCTSTR)IDD_DEV, pWnd->hWnd, (DLGPROC)DlgDevProc) )
		return FALSE;

	pWnd->pTable->ExecuteThread();
	return TRUE;
}



