// WListView.cpp : EBhELV
//

#include	"stdafx.h"
#include	"resource.h"
#include	"common.h"

#include	"wndproc.h"

// 
bool WListView::Init( void *pWnd )
{
	_rpti( "ListView: Init" );

	hwLV = CreateWindowEx(
				WS_EX_CLIENTEDGE,
				WC_LISTVIEW, NULL, WS_CHILD | LVS_REPORT | WS_VISIBLE,
				CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
				((WndMain*)pWnd)->hWnd, (HMENU)IDW_LV, hInst, NULL );
	_chkapi( hwLV );

	InitColumn();
	_rptd();

	return TRUE;
}

// I
void WListView::Exit()
{
}

// Ȑ
void WListView::InitColumn()
{
	// ListViewڏ
	char sCol[128];
	LVCOLUMN itCol;
	itCol.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_SUBITEM | LVCF_ORDER;
	itCol.pszText = sCol;
	itCol.cchTextMax = sizeof(sCol);
	itCol.cx = 48;

	LoadString( hInst, IDS_PGM, sCol, sizeof(sCol) );
	itCol.iSubItem = 2;
	itCol.iOrder = 2;
	ListView_InsertColumn( hwLV, 0, &itCol );

	LoadString( hInst, IDS_BANK, sCol, sizeof(sCol) );
	itCol.iSubItem = 1;
	itCol.iOrder = 1;
	ListView_InsertColumn( hwLV, 0, &itCol );

	LoadString( hInst, IDS_INST, sCol, sizeof(sCol) );
	itCol.cx = 320;
	itCol.iSubItem = 0;
	itCol.iOrder = 0;
	ListView_InsertColumn( hwLV, 0, &itCol );
}

// TCY
void WListView::WndSize( long Width, long Height )
{
	MoveWindow( hwLV, 0, 0, Width, Height, FALSE );
}

// Rs[
bool WListView::CopyItem( HWND hWnd )
{
	int i;
	int nItem = ListView_GetItemCount( hwLV );
	char sItem[128];
	char *pText;

	// ̊m
	HGLOBAL hMem = GlobalAlloc( GMEM_DDESHARE, nItem * sizeof(sItem) );
	if( !hMem )
		return FALSE;

	pText = (char*)GlobalLock( hMem );
	strcpy( pText, "\r\n" );
	_rptt( "ListView: Clipboard: Lock Memory" );

	// 
	for( i=0; i<nItem; i++ )
		if( ListView_GetItemState(hwLV, i, LVIS_SELECTED) == LVIS_SELECTED  ) {
			ListView_GetItemText( hwLV, i, 0, sItem, sizeof(sItem) );
			strcat( pText, sItem );
			strcat( pText, "\r\n" );
		}
	_rptt( "ListView: Clipboard: Copy to Memory" );

	GlobalUnlock( hMem );
	_rptt( "ListView: Clipboard: Unlock Memory" );

	// Nbv{[h
	if( !OpenClipboard(hWnd) )
		return FALSE;
	EmptyClipboard();
	_rptt( "ListView: Clipboard: Init" );

	SetClipboardData( CF_TEXT, hMem );
	CloseClipboard();
	_rptt( "ListView: Clipboard: Complete Linking" );

	return TRUE;
}

// ؂
bool WListView::CutItem( HWND hWnd )
{
	if( !CopyItem( hWnd ) )
		return FALSE;

	DeleteItem();
	return TRUE;
}

// ׂẴACe폜
bool WListView::DeleteAll()
{
	_rptt( "ListView: Delete All Items" );
	return ListView_DeleteAllItems( hwLV );
}

// IꂽACe̍폜
void WListView::DeleteItem()
{
	// ŌォsƂ܂
	int i;
	for( i=ListView_GetItemCount(hwLV)-1; i>=0; i-- )
		if( ListView_GetItemState(hwLV, i, LVIS_SELECTED) == LVIS_SELECTED  )
			ListView_DeleteItem( hwLV, i );
	_rptt( "ListView: Delete Items" );
}

// ׂđI
void WListView::SelectAll()
{
	_rptt( "ListView: Select All Items" );
	ListView_SetItemState( hwLV, -1, LVIS_SELECTED, LVIS_SELECTED );
}

// IĂACe
int WListView::GetSelectedItems()
{
	int i, n = 0;

	for( i=0; i<ListView_GetItemCount(hwLV); i++ )
		if( ListView_GetItemState(hwLV, i, LVIS_SELECTED) == LVIS_SELECTED  )
			n++;

	return n;
}

