// WStatus.cpp : EBhẼXe[^Xo[
//

#include	"stdafx.h"
#include	"resource.h"
#include	"common.h"

#include	"wndproc.h"

// 
bool WStatus::Init( HWND hWnd )
{
	// Xe[^Xo[̍쐬
	_rpti( "StatusBar: Init" );

	hwST = CreateStatusWindow(
						WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,
						NULL, hWnd, IDW_ST );
	_chkapi( hwST );
	_rptd();

	// devide part
	bIs2Part = TRUE;	// 2 part style
	DevidePart();

	// create icon
	_rpti( "StatusBar: Setting Icon" );

	hiDev = LoadImage( hInst, MAKEINTRESOURCE(IDI_DEV),
					  IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR );
	_sndm( hwST, SB_SETICON, 1, hiDev );
	_rptd();

	// create progress bar, not shown.
	RECT rt;
	_sndm( hwST, SB_GETRECT, 1, &rt );

	_rpti( "ProgressBar: Init" );

	hwPB = CreateWindowEx(
				WS_EX_STATICEDGE, PROGRESS_CLASS, NULL,
				WS_CHILD | PBS_SMOOTH,
				rt.left, rt.top,
				rt.right - rt.left, rt.bottom - rt.top,
				hwST, NULL, hInst, NULL );
	_chkapi( hwPB );
	_rptd();

	// make sure to show as top window
	SetWindowPos( hwPB, HWND_TOP, 0, 0, 0, 0,
		SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOMOVE );

	return TRUE;
}

// ől̐ݒ
void WStatus::SetMax( int iMax )
{
	_sndm( hwPB, PBM_SETRANGE, 0, MAKELONG(0, iMax) );
}

/*****	u[l 'true' ܂ 'false' ɋIɐݒ肵܂ (x̏)	*****/
#pragma warning( disable : 4800 )

// bZ[W(KCh)̕\
bool WStatus::SetTextGuide( char* sText )
{
	return (bool)_sndm( hwST, SB_SETTEXT, 0, sText );
}

// bZ[W(foCX)̕\
bool WStatus::SetTextDev( char* sText )
{
	return (bool)_sndm( hwST, SB_SETTEXT, bIs2Part?1:2,
		(!sText)?(LPARAM)sDevName:(LPARAM)strcpy(sDevName, sText) );
}

// \[X
bool WStatus::SetString( int iPart, UINT ids_msg )
{
	char sMsg[128];
	LoadString( hInst, ids_msg, sMsg, sizeof(sMsg) );
	return (bool)_sndm( hwST, SB_SETTEXT, iPart, sMsg );
}

/*****	u[l 'true' ܂ 'false' ɋIɐݒ肵܂ (x̏)	*****/
#pragma warning( default : 4800 )

// pl̕
void WStatus::DevidePart( int width )
{
	int iPart[3];
	int wndWidth;

	RECT rt;
	wndWidth = (width != -1)?(width):(GetClientRect(hwST, &rt), rt.right);

	if( bIs2Part ) {
		/*	2 parts style is following:

			+-----------------------+-----------+
			0						b			c(wndWidth)
			|						|    210	|

			iPart[] :				0			1
			value :					W-210		-1
		*/

		iPart[1] = -1;
		iPart[0] = wndWidth - 210;

		_sndm( hwST, SB_SETPARTS, 2, (LPINT)iPart );
	}

	else {
		/*	3 parts style is following:

			+---------------+-------+-----------+
			0				a		b			c(wndWidth)
			|				|  120	|    210	|

			iPart[] :		0		1			2
			value :			W-330	W-210		-1
		*/

		iPart[2] = -1;
		iPart[1] = wndWidth - 210;
		iPart[0] = wndWidth - 330;

		_sndm( hwST, SB_SETPARTS, 3, (LPINT)iPart );

		// progress bar
		RECT rt;
		_sndm( hwST, SB_GETRECT, 1, &rt );

		MoveWindow( hwPB, rt.left, rt.top,
			rt.right - rt.left, rt.bottom - rt.top, TRUE );
	}
}

// pl̕ύX
void WStatus::TogglePart()
{
	bIs2Part = bIs2Part?FALSE:TRUE;
	DevidePart();

	// progress bar
	_pstm( hwPB, PBM_SETPOS, (WPARAM)(int)0, 0 );
	ShowWindow( hwPB, bIs2Part?SW_HIDE:SW_SHOW );

	// icon
	_pstm( hwST, SB_SETICON, bIs2Part?1:2, hiDev );

	// device name
	SetTextDev();

	_rptt( "StatusBar: Toggle Part" );
}

// TCY
void WStatus::WndSize( long wndWidth, long wndHeight )
{
	RECT rt;

	// ړ
	GetWindowRect( hwST, &rt );
	MoveWindow( hwST, 0, wndHeight - rt.bottom,
		wndWidth, rt.right, FALSE );

	// pl
	DevidePart( wndWidth );
}

// Ԃ
long WStatus::GetHeight()
{
	RECT rt;
	GetClientRect( hwST, &rt );
	return rt.bottom;
}





