// WndProc.cpp : EBhE[vȂ
//

#include	"stdafx.h"
#include	"resource.h"
#include	"common.h"

#include	"wndproc.h"
#include	"dlgdevlist.h"

// EBhE[v
WndMain		*pWnd;
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch( message ) 
	{
		// j[I
		case WM_COMMAND:
			switch( LOWORD(wParam) ) {
				case IDM_EXIT:
					DestroyWindow( hWnd );
					break;

				case IDM_REDETECT:
					DDevlist dDevs;
					dDevs.DoDialog( pWnd );
					break;

				case IDM_COPY:
					pWnd->wLV.CopyItem( hWnd );
					break;

				case IDM_CUT:
					pWnd->wLV.CutItem( hWnd );
					break;

				case IDM_DELALL:
					pWnd->wLV.DeleteAll();
					break;

				case IDM_SELALL:
					pWnd->wLV.SelectAll();
					break;

				case IDM_DEL:
					pWnd->wLV.DeleteItem();
					break;
			}
			break;

		// I
		case WM_DESTROY:
			PostQuitMessage( 0 );
			break;

		// TCY
		case WM_SIZE:
			pWnd->WndSize( LOWORD(lParam), HIWORD(lParam) );
			break;

		// context right click
		case WM_CONTEXTMENU:
			/*	xPos = LOWORD(lParam);
				yPos = HIWORD(lParam);	*/
			HMENU hMenu;

			hMenu = GetSubMenu( GetMenu(hWnd), 1 );
			TrackPopupMenu( hMenu, TPM_LEFTALIGN | TPM_TOPALIGN,
				LOWORD(lParam), HIWORD(lParam), 0, hWnd, NULL );
			break;

		// I
		case WM_NOTIFY:
			if( ((LPNMLISTVIEW)lParam)->hdr.idFrom == IDW_LV )
				pWnd->WndNotify( (LPNMLISTVIEW)lParam );
			break;
	}
	return DefWindowProc( hWnd, message, wParam, lParam );
}

// 
bool WndMain::Init( CSoundFont *pSoundFont, Thread_ListTable *pThread_ListTable )
{
	// |C^
	pSf = pSoundFont;
	pTable = pThread_ListTable;
	pWnd = this;

	// \[X
	LoadString( hInst, IDS_TITLE, sTitle, sizeof(sTitle) );
	LoadString( hInst, IDS_CLASSNAME, sClassName, sizeof(sClassName) );

	// EBhENX
	_rpti( "MainWindow: Register Window Class" );

	InitClass();
	_rptd();

	// EBhE̍쐬
	_rpti( "MainWindow: Init" );

	hWnd = CreateWindowEx(
		0, sClassName, sTitle, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
		NULL, NULL, hInst, NULL );
	_chkapi( hWnd );
	_rptd();

	// IuWFNg
	wIList.Init();			// C[WXg
	wStatus.Init( hWnd );	// Xe[^X
	wLV.Init( this );		// LV

	_rptt( "MainWindow: Init Complete" );
	return TRUE;
}

// I
void WndMain::Exit()
{
	wLV.Exit();
}

// \
void WndMain::Show( const int nCmdShow )
{
	// TCY
	RECT rt;
	GetClientRect( hWnd, &rt );
	SetWindowPos( hWnd, NULL, 0, 0, 460, rt.bottom, SWP_NOZORDER | SWP_NOMOVE );

	// EBhE\
	ShowWindow( hWnd, nCmdShow );
	_rptt( "MainWindow: Show" );

	UpdateWindow( hWnd );
	_rptt( "MainWindow: Update" );
}

// EBhENX̓o^
ATOM WndMain::InitClass()
{
 	// EBhENX̓o^
	WNDCLASSEX wcex;
	wcex.cbSize			= sizeof(WNDCLASSEX); 
	wcex.style			= CS_CLASSDC;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInst;
	wcex.hIcon			= LoadIcon( hInst, (LPCTSTR)IDI );
	wcex.hCursor		= LoadCursor( NULL, IDC_ARROW );
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW);
	wcex.lpszMenuName	= (LPCSTR)IDM;
	wcex.lpszClassName	= sClassName;
	wcex.hIconSm		= NULL;

	return RegisterClassEx( &wcex );
}

// TCY
void WndMain::WndSize( const long wndWidth, const long wndHeight )
{
	wStatus.WndSize( wndWidth, wndHeight );
	wLV.WndSize( wndWidth, wndHeight - wStatus.GetHeight() );
}

// custom controls
void WndMain::WndNotify( LPNMLISTVIEW pnmv )
{
	if( pnmv->hdr.code == LVN_ITEMCHANGED ) {
		int n = wLV.GetSelectedItems();
		char sText[128], sRes[128];

		LoadString( hInst, IDS_ITEMS, sRes, sizeof(sRes) );
		sprintf( sText, sRes, n );

		wStatus.SetTextGuide( sText );
	}
}




