/////////////////////////////////////////////////////////////////////
//
//	XSoundFont.cpp - SoundFont Interface Class
//
//	Copyright (C) WanSystem Porject, 2000-2001.
//
//	(Revision 1.00)
//
/////////////////////////////////////////////////////////////////////
#define		_STDAFX_IMP_

//	INCLUDES	/////////////////////////////////////////////////////
#include	"stdafx.h"
#include	"xsoundfont.h"

//	DEFINES		/////////////////////////////////////////////////////
#define		__chkdll		if( !hDLL ) { return FALSE; }
#define		__fatalerr		{ FreeLibrary( hDLL ); return FALSE; }

#define		__ifapi(x)		if( (x) != SFERR_NOERR )
#define		__chkapi(x)		__ifapi(x) { return FALSE; } return TRUE

//	FUNCTIONS	/////////////////////////////////////////////////////
bool CSoundFont::ILoad()
{
	PSFMANAGER pManager = NULL;

	// init var
	hDLL = NULL;
	pAPI = NULL;

	// link DLL
	hDLL = LoadLibrary( SF_MASTER_MANAGER_FILENAME );
	__chkdll;

	// interface DLL
	pManager = (PSFMANAGER)GetProcAddress( hDLL, SF_FUNCTION_TABLE_NAME );
	if( !pManager )
		__fatalerr;

	// interface SoundFont API
	pManager->SF_QueryInterface( ID_SFMANL101API, (PDWORD)&pAPI );
	if( !pAPI )
		__fatalerr;

	// successfully interfaced
	return TRUE;
}

bool CSoundFont::IFree()
{
	__chkdll;

	// unlink DLL
	if( !FreeLibrary(hDLL) )
		return FALSE;

	// disable
	hDLL = NULL;
	pAPI = NULL;

	// successfully unlinked
	return TRUE;
}

bool CSoundFont::DevOpen( int nDevID )
{
	__chkdll;
	__chkapi( pAPI->SF_Open((WORD)nDevID) );
}

bool CSoundFont::DevClose( int nDevID )
{
	__chkdll;
	__chkapi( pAPI->SF_Close((WORD)nDevID) );
}

int CSoundFont::DevGetNum()
{
	WORD n;

	__chkdll;
	__ifapi( pAPI->SF_GetNumDevs(&n) )
		return 0;
	return (int)n;
}

bool CSoundFont::GetDevCaps( int nDevID, PSFCAPSOBJECT pCaps )
{
	__chkdll;
	__chkapi( pAPI->SF_GetDevCaps((WORD)nDevID, pCaps) );
}

bool CSoundFont::GetPresetDesc( int nDevID, int iBnk, int iPgm, char *sDesc )
{
	__chkdll;

	// preset number
	CSFMIDILocation sfLoc;
	sfLoc.m_BankIndex = (WORD)iBnk;
	sfLoc.m_PresetIndex = (WORD)iPgm;

	// buffer
	CSFBufferObject sfBuf;
	sfBuf.m_Buffer = sDesc;
	sfBuf.m_Size = 256;

	__chkapi( pAPI->SF_GetLoadedPresetDescriptor((WORD)nDevID, &sfLoc, &sfBuf) );
}

long CSoundFont::DevIsFree( int nDevID )
{
	return pAPI->SF_IsDeviceFree( (WORD)nDevID );
}


